"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Cell;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = require("./styled-components.js");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
Copyright (c) 2018-2020 Uber Technologies, Inc.

This source code is licensed under the MIT license found in the
LICENSE file in the root directory of this source tree.
*/
// When used with Grid, Cell does not actually return anything.
// All of the props are forwarded to a StyledCell inside of Grid.
function Cell(_ref) {
  var align = _ref.align,
      children = _ref.children,
      order = _ref.order,
      skip = _ref.skip,
      span = _ref.span;
  return _react.default.createElement(_styledComponents.StyledCell, {
    $align: align,
    $order: order,
    $skip: skip,
    $span: span
  }, children);
}